;=============================================================================
;  GETSETGS   Paradox 4.5 DOS
;  Author: Greg T. Prachyl  Ennis, Tx
;  Date: 6/95
;  Note: This script has little or no error handling.  It could be nicely
;     enhanced, but I don't have the time!  I only wrote what I needed now.
;     You may well have a situation that I don't.  Please REVIEW it before
;     using it; BACKUP your data; TEST it; do whatever you wish with it.
;     Requires the TABLEINFO command, so it only works with Paradox DOS 4.5
;  Procedure:  Get ValChecks & Settings for FIELDS in all tables in the
;     current directory, to a table named Tabsetgs.  Backup of previous
;     Tabsetgs is saved in table Tabsetg$.
;  VIEW Tabsetgs after you run this and browse the data, especially the
;     DEFAULT column.  I have found garbage characters appended to default
;     values.  I can't be certain where these are coming from.  I would be
;     interested to know if others get this garbage.
;  Please Use freely while understanding that I will not be responsible
;     for any aspect of its' use.
;  Delete the following RETURN to run, after reading the above.

RETURN " Please edit and review the GETSETGS script before running "

SAVETABLES
CLEARALL
RESET
IF ISTABLE("Tabsetgs") THEN
   IF ISTABLE("Tabsetg$") THEN
      DELETE "Tabsetg$"
   ENDIF
   COPY "Tabsetgs" "Tabsetg$"
   IF NOT ISEMPTY("Tabsetgs") THEN
      EMPTY "Tabsetgs"
   ENDIF
ELSE
   CREATE "Tabsetgs"
   "TABLE" : "A8",        "FIELD" : "A24",        "MIN" : "A24",
   "MAX" : "A24",         "DEFAULT" : "A24",      "PICTURE" : "A24",
   "LOOKUP" : "A8",       "LOOKUPHELP" : "A5",    "LOOKUPFILL" : "A5",
   "REQUIRED" : "A5",     "AUTO-PICTURE" : "A5",  "AUTO-LOOKUP" : "A5",
   "AUTO-FILLED" : "A5",  "POSITION" : "A24",     "WIDTH" : "A24",
   "FORMAT" : "A24",      "DECIMAL PLACES" : "A5"
ENDIF

; The following "Rebuild" ("list") table is used as the source for tables
; to gather settings for.  I have also used it to run Tutility -Rebuild
; from within Paradox with RUN.  As memory requirements to do this are
; strict, and running Tutility from Paradox is not recommended, I have
; not included the rebuild script here.
; The rebuild table can be useful for performing whatever you may
; need to on the list of tables, between this script, and script SETSETGS,
; which restores the captured Valchecks and Format settings to the tables.

; Delete any unwanted tables from rebuild list - Temporary tables, or any
; that you just don't want to capture or set settings for.
; You could insert an interactive edit proc here.

{Tools} {Info} {Inventory} {Tables} ENTER
COEDITKEY
MOVETO [NAME]
LOCATE "List"
IF Retval THEN
   DEL
ENDIF
LOCATE "Struct"
IF Retval THEN
   DEL
ENDIF
LOCATE "Tabsetgs"
IF Retval THEN
   DEL
ENDIF
LOCATE "Tabsetg$"
IF Retval THEN
   DEL
ENDIF
LOCATE "Rebuild"
IF Retval THEN
   DEL
ENDIF
DO_IT!
CLEARIMAGE
IF ISTABLE("Rebuild") THEN
   DELETE "Rebuild"
ENDIF
RENAME "List" "Rebuild"

; Gather Table Valchecks & Settings for all Tables in current directory.

VIEW "Tabsetgs", "Rebuild"
COEDITKEY
SCAN
   FileChoice = [NAME]
   MESSAGE " Gathering Valchecks & Settings for: ", FileChoice, " "
   MOVETO "Tabsetgs"
   TABLEINFO FileChoice FIELDS TO DYNARRAY TabFields
   FOREACH One IN TabFields
      TABLEINFO FileChoice VALCHECKS One TO ValChecks   ; valchecks for field
      TABLEINFO FileChoice SETTINGS One TO SetChecks    ; settings for field
      [TABLE] = FileChoice
      [FIELD] = One
      FOREACH Two IN ValChecks
         MOVETO FIELD Two
         [] = STRVAL(ValChecks[Two])
      ENDFOREACH
      FOREACH Two IN SetChecks
         MOVETO FIELD Two
         [] = STRVAL(SetChecks[Two])
      ENDFOREACH
      DOWN
   ENDFOREACH
   MOVETO "Rebuild"
ENDSCAN
DO_IT!
SAVETABLES
CLEARALL

; Delete entries from Tabsetgs with no Valchecks or Settings

{Ask} {Tabsetgs}
[#] = "delete"
[MIN] = "BLANK"
[MAX] = "BLANK"
[DEFAULT] = "BLANK"
[PICTURE] = "BLANK"
[LOOKUP] = "BLANK"
[LOOKUPHELP] = "BLANK"
[LOOKUPFILL] = "BLANK"
[REQUIRED] = "BLANK"
[AUTO-PICTURE] = "BLANK"
[AUTO-LOOKUP] = "BLANK"
[AUTO-FILLED] = "BLANK"
[POSITION] = "BLANK"
[WIDTH] = "BLANK"
[FORMAT] = "BLANK"
[DECIMAL PLACES] = "BLANK"
DO_IT!
SAVETABLES
CLEARALL
VIEW "Tabsetgs"

; Notes:
;    TABLEINFO "Table" SETTINGS "Field": Page 60 of the upgrade guide
;       says that "DECIMALS" is an index in the resulting array.
;       The index is actually "DECIMAL PLACES".
;    TABLEINFO "Table" VALCHECKS "Field": Page 60 of the upgrade guide
;       says that "AUTO-FILL" is an index in the resulting array.
;       The index is actually "AUTO-FILLED".
;    TABLEINFO "Table" VALCHECKS "Field": In the resulting array, the
;       value in the the "LOOKUP" index (the name of the lookup table),
;       will contain all or part of the file extension if the table name is
;       less than 8 characters. (eg "Table00." or "Table0.d" or "Table.db")
; 
;    The following scrubs the table in preperation for script SETSETGS.

COEDITKEY
SCAN
   IF [FORMAT] = "COMMAS" THEN
      [FORMAT] = "COMMA"          ; {Image} {Format} uses "COMMA"
   ENDIF
   IF [LOOKUP] > "" THEN
      TempNum = SEARCH(".", [LOOKUP])
      IF TempNum > 0 THEN
         [LOOKUP] = SUBSTR([LOOKUP], 1, TempNum - 1)
      ENDIF
   ENDIF
ENDSCAN
DO_IT!
SAVETABLES
CLEARALL
RESET
;=============================================================================
